import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class player here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class player extends Actor
{
    
    private boolean cJump=false;     // are we jumping
    private int sJump = 14;         // height to jump
    private int jumpDelay = 0;     // delay next jump
   
    private int vSpeed = 0;
    private int vGravity = 2;
        
    private boolean death = false;
    private int lives = 3;
            
    private Score myLives;
    
    private int sxPos;              // start position x
    private int syPos;              // start position y
    private int maxSpeed = 3;       // Maximum speed
    private double cSpeed;
    
    //images for player
    private GreenfootImage img1;    // right image
    private GreenfootImage img2;    // left image
    private GreenfootImage img3;
    
    //score
    private int score;
    private Score myScore;
    
    //Pause player after all eggs collected
    private boolean pausePlayer = false;
    
    /**
     * Constructor for player
     */
    
    public player(Score aScore, Score aLive) {
 //       img1 = new GreenfootImage("pelican.png");
 //       img2 = new GreenfootImage("pelican1.png");
        img1 = new GreenfootImage("right1.png");
        img2 = new GreenfootImage("left1.png");
        img3 = new GreenfootImage("climb1.png");
        myScore = aScore;
        myLives = aLive;
        cSpeed = 0;
    }
    
    /**
     * Act - do whatever the player wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(!pausePlayer) {
            
            if(!death) {            
                move();
                checkFall();
                checkLift();
                checkEgg();
                checkSnake();
                checkSpike();
                reduceSpeed();
            }
            else
            {
                setRotation(getRotation()+5);
            
            }

            checkDeath();
        }
    }    
    
    /**
     * Check key press and then move and change images
     */
    
    public void move()
    {
        
        
        if(Greenfoot.isKeyDown("right")) {
            if(cSpeed<maxSpeed) {
                cSpeed++;
            }
            setImage(img1);
            if(!isRight()){
                setLocation(getX()+(int)cSpeed,getY());
            }
        }
        
        if(Greenfoot.isKeyDown("left")) {
            if(cSpeed>-maxSpeed) {
                cSpeed--;
            }
            setImage(img2);
            if(!isLeft()){
                setLocation(getX()+(int)cSpeed, getY());
            }
        }
        
        
        if(Greenfoot.isKeyDown("space")) {
            if(isLift() || isGround()){
               checkJump();
             }
         }
         

         if(Greenfoot.isKeyDown("up")) {
       
            if(isLift() || (!isUp() && !isLadder() && isGround())) {
                 checkJump();
                }
            else { 
                if (isLadder()){
                    setImage(img3);
                   setLocation(getX(), getY() - 1);
                   }
                }
        }
        
        if(Greenfoot.isKeyDown("down")) {
            if(isLadder()) {
                setLocation(getX(), getY() + 1);
            }
        }
        
    }
    
    /**
     * Reduce Speed
     */
    
    public void reduceSpeed()
    {
        if(cSpeed!=0) {
            if(cSpeed>0) {
                cSpeed = cSpeed - 0.5;
            }
            else {
                cSpeed = cSpeed + 0.5;
            }
        }
    }
    /**
     * Jump.. reverse gravity and make sure space is not hit again
     */
    public void checkJump()
    {
        
        if(!cJump){
            cJump = true;
            vSpeed = -sJump;
            fall();
         }
    }
    

    /**
     * Pause Player. A method that called from the world1 object
     * to set the flag pausePlayer, to true and false, so that the
     * player cannot move.
     */
    
    public void flipPause()
    {
        pausePlayer = !pausePlayer;
    }
    
    /**
     * If one a Lift, move with Lift
     */
    public void checkLift()
    {
        if(isLift()) {
            setLocation(getX(), getY()-1);
        }
    }
    
    /**
     * Check falling lift. Method that loops through the current Vertical
     * speed and checks if moving pass a lift object. If true, set the
     * vertical speed to i
     */
    public void checkFallingLift()
    {
        for(int i =0; i<vSpeed;i++){
            Actor act = getOneObjectAtOffset(0, (getHeight()/2) +i, Lift.class);
            if(act !=null) {
                vSpeed = i;
                break;
                }
         } 
    }
    
     /**
     * Check falling ground. Method that loops through the current Vertical
     * speed and checks if moving pass a ground object. If true, set the
     * vertical speed to i
     */
    public void checkFallingGround()
    {
        
        for(int i =0; i<vSpeed;i++){
            Actor act = getOneObjectAtOffset(0, (getHeight()/2) +i, Back1.class);
                if(act !=null) {
                    vSpeed = i;
                    break;
                }
            } 
    }

    /**
     * IsLadder check to see if player is on ladder
     */
    
    public boolean isLadder()
    {
        Actor onLadder = getOneObjectAtOffset(0,0, Ladder.class);
        return onLadder !=null;
    }
    
 
    /**
     * IsLift Check to see player hit ground
     */
    
    public boolean isLift()
    {
        Actor act = getOneObjectAtOffset(0, (getHeight()/2) + vSpeed, Lift.class);
        return act != null;
    }
    
    
    /**
     * IsGround Check to see player hit ground
     */
    public boolean isGround()
    {
        Actor act = getOneObjectAtOffset(0, (getHeight()/2) + vSpeed-2, Back1.class);
        return act != null;
    }
    
    /**
     * IsRight Check to see player meeting right block
     */
    public boolean isRight()
    {
        Actor act = getOneObjectAtOffset(getWidth()/2, 0, Back1.class);
        return act != null;
    }
    
    
    /**
     * IsLeft Check to see player meeting right block
     */
    public boolean isLeft()
    {
        Actor act = getOneObjectAtOffset(0-getWidth()/2, 0, Back1.class);
        return act != null;
    }
 
    /**
     * IsUp Check to see player meeting right block
     */
    public boolean isUp()
    {
        Actor act = getOneObjectAtOffset(0,0-(getHeight()/2)-2, Back1.class);
        return act != null;
    }
    
    
        
    /**
     * Check fall..
     */
    public void checkFall()
    {
        if(isGround() || isLift()) {
            vSpeed = 0;
            cJump = false;
        }
        else
        {
            fall();
        }
    }
    
    /**
     * Fall method. Drops player until they hit ground
     */
    public void fall()
    {
        if(!isLadder()) {
            checkFallingLift();     // check to see if falling past a lift
            checkFallingGround();  //  check to see if falling past ground
            setLocation(getX(), getY()  + vSpeed);
            vSpeed = vSpeed + vGravity;
        }
    }
    
    /**
     * Hit an Egg
     */
    
    public void checkEgg()
    {
        Actor anEgg = getOneObjectAtOffset(0,0, Egg.class);
        if(anEgg !=null) {
            score = score + 50;
            myScore.setText("Score : " + score);
            getWorld().removeObject(anEgg);
        }
    }
    
    /**
     * Set position
     */
    public void setPosition(int xPos, int yPos)
    {
        sxPos = xPos;
        syPos = yPos;
        setLocation(sxPos,syPos);
    }
    
    /**
     * Check spike 
     */
    public void checkSpike()
    {
        if(isSpike()) {
            death = true;
        }
    }
    
    /**
     * isSpike, check player falling on spike
     */
    public boolean isSpike()
    {
        Actor aSpike = getOneIntersectingObject(Spike.class);
        return aSpike !=null;
    }
        
    /**
     * Return death state
     */
    
    public boolean returnDeath()
    {
        return death;
    }
    
    /**
     * Check Snake at the same position
     */
    public void checkSnake()
    {
        if(isSnake()) {
            death = true;            
        }
    }
    
    /**
     * Check isSnake
     */
    public boolean isSnake()
    {
        Actor aSnake = getOneIntersectingObject(snake.class);
        return aSnake !=null;
    }
        
    /**
     * Check Death
     */
    public void checkDeath()
    {
        if(death) {
            if(lives>0) {
                if(Greenfoot.isKeyDown("enter")){
                    death = false;
                    lives = lives -1;
                    myLives.setText("Lives : " + lives); 
                    setRotation(0);
                    setLocation(sxPos,syPos);
                    }
                 }
             else {
                 Greenfoot.stopSimulation();
                }
        }
    }
}
