import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.awt.Color;
/**
 * Write a description of class world1 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class world1 extends World
{
    int level = 1;
    
    int maxLevel = 6;           // number of lives
    String slevel;
    Score score;
    Score levelText;
    Score deathText;
    Score lives;
    
    private player player1;
    private boolean changeLevel = false;
    private boolean deathMessage = false;
    
    /**
     * Constructor for objects of class world1.
     * 
     */
    public world1()
    {    
        
        super(512, 512, 1);
        setPaintOrder(Score.class, player.class, snake.class, Egg.class, 
                        Ladder.class,Back1.class);
        
        score = new Score("Score : 0");
        addObject(score, 100,15);
        
        
        lives = new Score("Lives : 3");
        addObject(lives, 480, 15);
        
        //create player
        player1 = new player(score, lives);
        addObject(player1,200,200);
       
        // Create message
        levelText = new Score("Level Completed!!  Hit the Return Key", Color.WHITE);
        deathText = new Score("Oh No!! Hit Return to Continue", Color.RED);
        drawScreen(); 
  
    }
    
    public void act()
    {
        checkEggs();    // check whether there is any eggs left on level
        checkDeath();
    }

    /**
     * New method to fix bug, found by Keenan, 
     * and Poul Henriksen for supplying the fix. 
     */
    public void checkEggs()
    {
        if(!changeLevel && noEggs()) {
            changeLevel = true;
            player1.flipPause();        // Stop player moving.
            printMessage2();
        }
        
        if(changeLevel && enterPressed()) {
            removeItems();              // remove objects
            removeObject(levelText);    // remove text from screen
            changeLevel=false;
            level = level + 1;          // increase level 
            if(level> maxLevel) {
                 level = 1;        }  
            player1.flipPause();        // start player moving
            drawScreen();               // draw new screen
        }
    }
    
    /**
     * Print Message when level is completed
     */
    public void printMessage2()
    {
        addObject(levelText, 400,250);    
    }
        
    /**
     * get the return key
     */
    public boolean enterPressed()
    {
        return Greenfoot.isKeyDown("enter");
    }

    /**
     * Check Death method
     * Calls methods from player, to find if player as died. If so
     * show message.
     */
    public void checkDeath()
    {
        if(player1.returnDeath()) {
            addObject(deathText,400,250);
            deathMessage = true;
            Greenfoot.delay(1);
        }
        
        if(player1.returnDeath()==false && deathMessage == true) {
            removeObject(deathText);
            deathMessage = false;
        }              
    }
    
    /**
     * Check whether the player as collected all the eggs
     */
    public boolean noEggs()
    {
        List eggs = getObjects(Egg.class);
        if(eggs.isEmpty()){
            return true;}
        return false;
       
    }
    
    /**
     * Remove all items from first level
     */
    public void removeItems()
    {
        List backgrounds = getObjects(Back1.class);
        removeObjects(backgrounds);
        
        List allLadders = getObjects(Ladder.class);
        removeObjects(allLadders);
        
        List allSnakes = getObjects(snake.class);
        removeObjects(allSnakes);
        
        List allLifts = getObjects(Lift.class);
        removeObjects(allLifts);
        
        List allSpikes = getObjects(Spike.class);
        removeObjects(allSpikes);
    }
    
    // level design... 
    
    public void levelSetup()
    {
        
        switch(level){         
            case 1: 
                slevel ="0000011111000000"+     // 1. platform
                        "0000000000000000"+     // 2. player
                        "0000000000000000"+     // 3. Ladder
                        "0000005000000000"+     // 4. Egg
                        "0000011111000000"+     // 5. Snake
                        "0000000000000000"+     // 6. platform Grass
                        "0000000000000000"+     
                        "0000000000403000"+
                        "0000000000113000"+
                        "4000000000003000"+
                        "1100000000003003"+     // a. Lift
                        "0000000000003113"+
                        "0000000000000003"+
                        "0004000020000003"+
                        "00a1111111110003"+
                        "1111111111111111";
                break;
             case 2:
                slevel ="0000000000000000"+
                        "0000000000000000"+
                        "0000000000000000"+
                        "0000005400300000"+
                        "0000011111300000"+
                        "0000000000300000"+
                        "0040300000300000"+
                        "0011300004300000"+
                        "0000300001100000"+
                        "0300300000000300"+
                        "1311100001111310"+
                        "0300000000000300"+
                        "0300000200000300"+
                        "0300011111000300"+
                        "0304000500004300"+
                        "1111111111111111";
                break;
             case 3:
                slevel ="0000000000000000"+
                        "0000000000000000"+
                        "4000030040003000"+
                        "6040036666s63000"+
                        "0066630000003000"+
                        "0000000000003040"+
                        "0000000000003666"+
                        "0000000003003000"+
                        "0000000003005400"+
                        "4000300403666600"+
                        "6040366663000000"+
                        "0066300000000000"+
                        "0000300000000000"+
                        "0000300000000000"+
                        "0400305400040002"+
                        "6666666666s66s66"; 
                break;  
              case 4:
                slevel ="0000000000000000"+ 
                        "0000000000000000"+ 
                        "0000000000000000"+ 
                        "0400300000000000"+ 
                        "01s1300000000000"+ 
                        "0000304000000000"+ 
                        "0000311000000004"+ 
                        "0000300000300401"+ 
                        "0000300000311100"+ 
                        "0503350400300000"+ 
                        "1113111110300000"+ 
                        "0003000000000000"+ 
                        "0003000000000000"+ 
                        "0003000000000000"+ 
                        "0401004002000000"+ 
                        "111111111111111s"; 
 
               break;   
             case 5:
                slevel ="0000000000000000"+ 
                        "0000000000000000"+ 
                        "0000000000000000"+ 
                        "0000000000000000"+ 
                        "4000000000000004"+ 
                        "6040300040000006"+ 
                        "0066366060600000"+ 
                        "0000300000000000"+ 
                        "0000345000300000"+ 
                        "0000366666300004"+ 
                        "0000300000300006"+ 
                        "3040300000600000"+ 
                        "36663000000a0a00"+ 
                        "3000000000000000"+ 
                        "3400002000400000"+ 
                        "666s6666666s6s66"; 
               break;  
            case 6:
                slevel ="0000000000000000"+ 
                        "0003004000400040"+ 
                        "00636060606s6060"+ 
                        "0003000000000000"+ 
                        "0003000000000000"+ 
                        "0003000400000300"+ 
                        "006366s660066300"+ 
                        "0000000000000300"+ 
                        "0300000000400300"+ 
                        "036660000s666300"+ 
                        "0300000000000000"+ 
                        "0300000000000000"+  
                        "0304000000423000"+ 
                        "0366606600663000"+ 
                        "0005000000000000"+ 
                        "6666666666666666";
              break;          
            }
    }
    
    /**
     * Draw Screen... reads in level string, which a 15 by 15
     * screen.
     * 0 = no background
     * 1 = Background 1
     */
    public void drawScreen()
    {
        char element;
        levelSetup();
        
        for(int i = 0; i<16; i++)
        {
            for(int j = 0; j<16; j++)
            {
                element = slevel.charAt(j+(i*16));
                switch(element) {
                    case '0':
                        break;
                    case '1':
                        createBack1((j*32)+16,(i*32)+16);
                        break;
                    case '2':
                        createPlayer1((j*32)+16,(i*32)+16);
                        break;
                    case '3':
                        createLadder((j*32)+16,(i*32)+16);
                        break;
                    case '4':
                        createEgg((j*32)+16,(i*32)+16);
                        break;
                    case '5':
                        createSnake((j*32)+16,(i*32)+16);
                        break;
                    case '6':
                        createBack2((j*32)+16,(i*32)+16);
                        break;
                    case 'a':
                        createLift((j*32)+16,(i*32)+16);
                        break;
                    case 's':
                        createSpike((j*32)+16,(i*32)+16);
                        break;
                    }
                        
            }
        }
    }
    
    
    /**
     * Create background method
     */
    public void createBack1(int xPos, int yPos)
    {
        addObject(new Back1(1), xPos, yPos);
    }
    
    public void createBack2(int xPos, int yPos)
    {   
        addObject(new Back1(2), xPos, yPos);
    }
    
    /**
     * Create player method
     */
    
    public void createPlayer1(int xPos, int yPos)
    {
        player1.setPosition(xPos,yPos);
        //addObject(new player(score), xPos, yPos);
    }
    
    /**
     * Create ladder
     */
    public void createLadder(int xPos, int yPos)
    {
        addObject(new Ladder(), xPos, yPos);
    }
    
    /**
     * Create Egg
     */
    public void createEgg(int xPos, int yPos)
    {
        addObject(new Egg(), xPos, yPos);
    }
    
    /**
     * Create a Snake
     */
    public void createSnake(int xPos, int yPos)
    {
        addObject(new snake(), xPos, yPos);
    }
    
    /**
     * Create a Lift
     *  param. int Speed, start Position, end Position
     */
     public void createLift(int xPos, int yPos)
     {
        addObject(new Lift(1, yPos, yPos-(32*8)), xPos,yPos);    
     }
     
     /**
      * Create Spike
      */
     public void createSpike(int xPos, int yPos)
     {
         addObject(new Spike(), xPos, yPos);
     }
}
